/*
 *  Copyright 2003-2004. Airbee Wireless Corporation. All rights reserved.
 *	This program is protected by US and International copyright laws.
 *
 *
 *
 *
 *	Warning: This program is protected by copyright law and international
 *	treaties. Unauthorized reproduction or distribution of this program, or
 *	any portion of it, may result in severe civil or criminal penalties, and
 *	will be prosecuted to the maximum extent possible under the law.
 */

#ifndef _ABZB_FOUR_NODE_APP_H_
#define _ABZB_FOUR_NODE_APP_H_

/******Global definitions and type definitions*********************/

#define CO_ORDINATOR                //device config as CO_ORDINATOR
//#define ROUTER1                     //device config as ROUTER1
//#define ROUTER2                     //device config as ROUTER2
//#define ROUTER3                     //device config as ROUTER3

//to eliminate the defn in preprocessor path in "options"
#if (defined(ROUTER1) || defined(ROUTER2) || defined(ROUTER3))
    #define ROUTE
#endif


#define NULL    ((void*) 0 )
#define NULL_PTR    ((void*) 0 )

#define	       PASS 	      1
#define	       FAIL	      0

#define        SET            1
#define        CLEAR          0
#define        ENABLED        1
#define        DISABLED       0
#define        TRUE           1
#define        FALSE          0
#define        SUCCESS        1
#define        FAILURE        0
#define        GOOD_TX        0
#define        BAD_TX         1
#define        ZERO           0

#define M_ABZB_APP_FRMN_JOIN_FAILURE     (0x70)      //if joining/formation fails, then this ID is posted in APP_MBX
#define M_ABZB_APP_LED_FLASH_DURATION    (500)        //500 ms
#define FFD
#define V_ABZB_APP_TASK_Main()   V_ABZB_MAC_Main_Airbee_AppTask0()    //should not be changed

#define ABZB_ASP_TI_SWITCH            //To enable the TI switch
#define ABZB_ASP_TI_LED               //To enable the TI LED

#define M_ABZB_LOGICAL_CHANNEL              (0x12)          //Logical cahnnel selection RANGE : 11>= M_ABZB_LOGICAL_CHANNEL <= 26
#define M_ABZB_SCAN_CHANNELS                ((UINT32)1<<M_ABZB_LOGICAL_CHANNEL)
#define M_ABZB_SCAN_DURATION                (0x06)          //SCAN DURATION <15
#define M_ABZB_BEACONORDER                  (0x0F)          //Should be 0x0F for non-beacon mode
#define M_ABZB_SUPERFAMEORDER               (0x0F)          //SUPER FRAME DURATION
#define M_ABZB_PANID                        (0x0001)        //PANID
#define M_ABZB_PERMIT_DURATION              (0xFF)          //MAXIMUM PERMIT DURATION

#define M_ABZB_STACK_PROFILE                (0x05)          //STACK PROFILE !!! SHOULD NOT BE CHANGED
#define M_ABZB_ZADKV2_CO_ORDINATOR          (0x00)          //DEVICE ROLE ID
#define M_ABZB_ZADKV2_ROUTER1               (0x01)          //DEVICE ROLE ID
#define M_ABZB_ZADKV2_ROUTER2               (0x02)          //DEVICE ROLE ID
#define M_ABZB_ZADKV2_ROUTER3               (0x03)          //DEVICE ROLE ID

#define M_ABZB_PROTOCOL_ID_PERMIT_JOIN      (0x04)          //Protocol id
#define M_ABZB_PROTOCOL_ID_APP_DATA         (0x05)          //Protocol id
#define M_ABZB_APP_DATA_NSDUHANDLE          (200)           //NSDU HANDLE
#define M_ABZB_APP_DATA_NSDULENGTH          (0x01)          //NSDU LENGTH

#define M_ABZB_ALLOWABLE_DEVICES_1          (0x01)          //ALLOWABLE DEVICES CAN BE CHANED BY USER DEPENDING ON HIS REQ.
#define M_ABZB_ALLOWABLE_DEVICES_2          (0x02)          //ALLOWABLE DEVICES CAN BE CHANED BY USER DEPENDING ON HIS REQ.


#define SEND_MESSAGE(mailbox_ptr,message)	(fnS_Os_SendMessage(mailbox_ptr,(tMailMsgType)message))
#define GET_MESSAGE(mailbox_ptr,messageptr)	(fnS_Os_GetMessage(mailbox_ptr,(tMailMsgType*)messageptr))
#define MAILBOX_SIZE       8     /* Max No. of messages that can be held in a mailbox. Max is 256 */
                                  /* This has to be one of 2, 4, 8, 16, 32, 64, 128, 256 */

#define MAILBOX_2     &MailBox_Array[2]
#define APP_MBX             MAILBOX_2

/******The below defns should not be changed****************/
#define NLDE_DATA_REQUEST			0xa0

#define NLDE_DATA_CONFIRM			0xb0
#define NLDE_DATA_INDICATION			0xb1

#define NLME_NETWORK_DISCOVERY_REQUEST		0xa1
#define NLME_NETWORK_FORMATION_REQUEST		0xa2
#define NLME_PERMIT_JOINING_REQUEST		0xa3
#define NLME_START_ROUTER_REQUEST		0xa4
#define NLME_JOIN_REQUEST			0xa5
#define NLME_DIRECT_JOIN_REQUEST		0xa6
#define NLME_LEAVE_REQUEST			0xa7
#define NLME_RESET_REQUEST			0xa8
#define NLME_SYNC_REQUEST			0xa9
#define NLME_GET_REQUEST			0xaa
#define NLME_SET_REQUEST			0xab


#define NLME_NETWORK_DISCOVERY_CONFIRM		0xb2
#define NLME_NETWORK_FORMATION_CONFIRM		0xb3
#define NLME_PERMIT_JOINING_CONFIRM		0xb4
#define NLME_START_ROUTER_CONFIRM		0xb5
#define NLME_JOIN_CONFIRM			0xb6
#define NLME_JOIN_INDICATION			0xb7
#define NLME_DIRECT_JOIN_CONFIRM		0xb8
#define NLME_LEAVE_CONFIRM			0xb9
#define NLME_LEAVE_INDICATION			0xba
#define NLME_RESET_CONFIRM			0xbb
#define NLME_SYNC_CONFIRM			0xbc
#define NLME_SYNC_INDICATION			0xbd
#define NLME_GET_CONFIRM			0xbe
#define NLME_SET_CONFIRM			0xbf
#define NLME_GET_RT_CONFIRM                     0xae
#define NLME_GET_NT_CONFIRM                     0xaf

#define COORDINATOR                             0x00
#define ROUTER                                  0x01
#define NODE                                    0x02

#define V_ABZB_Timer_Soft_set_timer3(ABZB_Uch_TimerNo,ABZB_Ul_time,ABZB_St_MailBoxNo) \
                   (fnLoad_SwTimer(ABZB_Ul_time,   \
                                   ABZB_St_MailBoxNo, ABZB_Uch_TimerNo))

#define         M_ABZB_LED1                          (0x01)
#define         M_ABZB_LED2                          (0x02)
#define         M_ABZB_LED3                          (0x03)
#define         M_ABZB_LED4                          (0x04)

#define M_DEBOUNCE_EVENT        150    //added for debounce event, which this ID will be posted in APP_MBX
#define M_ABZB_DSP_KEYDEBOUNCE (100)//Key debounce time 100 Milli Seconds

#define		M_ABZB_DSP_PORT1INPUT		P1IN	
#define		M_ABZB_DSP_PORT2INPUT		P2IN
#define		M_ABZB_DSP_PORT3INPUT		P3IN
#define		M_ABZB_DSP_PORT4INPUT		P4IN
#define		M_ABZB_DSP_PORT5INPUT		P5IN
#define		M_ABZB_DSP_PORT6INPUT		P6IN

#define		M_ABZB_DSP_PORT1OUTPUT		P1OUT
#define		M_ABZB_DSP_PORT2OUTPUT		P2OUT
#define		M_ABZB_DSP_PORT3OUTPUT		P3OUT
#define		M_ABZB_DSP_PORT4OUTPUT		P4OUT
#define		M_ABZB_DSP_PORT5OUTPUT		P5OUT
#define		M_ABZB_DSP_PORT6OUTPUT		P6OUT

// PORT DIRCTIONS

#define		M_ABZB_DSP_PORT1DIR		P1DIR
#define		M_ABZB_DSP_PORT2DIR		P2DIR
#define		M_ABZB_DSP_PORT3DIR		P3DIR
#define		M_ABZB_DSP_PORT4DIR		P4DIR
#define		M_ABZB_DSP_PORT5DIR		P5DIR
#define		M_ABZB_DSP_PORT6DIR		P6DIR

#define         M_EXTERNAL_INT_ENABLE_REG           P1IE
#define         M_EXTERNAL_INT_EDGE_SELECT_REG      P1IES

#define 	M_ABZB_LAMP1_SLC_PORT           (P1OUT)     // Defined for SLC On/Off for Lamp1 (bit 4)
#define 	M_ABZB_LAMP2_SLC_PORT		(P1OUT)     // Defined for SLC On/Off for Lamp2 (bit 2)
#define 	M_ABZB_LAMP3_SLC_PORT		(P1OUT)     // Defined for SLC On/Off for Lamp3 (bit 4)

/* FOR SLC VALUES:
switch ON and OFF the SLC lamps
=========================================================== */

#define 	M_ABZB_LAMP1_SLC_ON            	(M_ABZB_LAMP1_SLC_PORT |= BIT0)
#define 	M_ABZB_LAMP2_SLC_ON		(M_ABZB_LAMP2_SLC_PORT |= BIT1)
#define 	M_ABZB_LAMP3_SLC_ON		(M_ABZB_LAMP3_SLC_PORT |= BIT2)

#define 	M_ABZB_LAMP1_SLC_OFF            (M_ABZB_LAMP1_SLC_PORT &= NBIT0)
#define 	M_ABZB_LAMP2_SLC_OFF	        (M_ABZB_LAMP2_SLC_PORT &= NBIT1)
#define 	M_ABZB_LAMP3_SLC_OFF		(M_ABZB_LAMP3_SLC_PORT &= NBIT2)

#define 	M_ABZB_LAMP1_SLC_TOGGLE       	(M_ABZB_LAMP1_SLC_PORT ^= BIT0)
#define 	M_ABZB_LAMP2_SLC_TOGGLE	        (M_ABZB_LAMP2_SLC_PORT ^= BIT1)
#define 	M_ABZB_LAMP3_SLC_TOGGLE		(M_ABZB_LAMP3_SLC_PORT ^= BIT2)


typedef unsigned char		BOOL;	/* Size - 8 bit, Range 0 to 1					*/

typedef unsigned char		BYTE;	/* Size - 8 bit, Range 0 to 255					*/
typedef unsigned char		UCHAR;	/* Size - 8 bit, Range 0 to 255					*/

typedef unsigned char		UINT8;	/* Size - 8 bit, Range 0 to 255					*/
typedef signed	 char		INT8;	/* Size - 8 bit, Range -128 to 127				*/

typedef	unsigned int 		UINT16;	/* Size - 16 bit, Range 0 to 65535				*/
typedef	int 			INT16;	/* Size - 16 bit, Range -32768 to 32767			*/

typedef	unsigned long		UINT32;	/* Size - 32 bit, Range 0 to (2^32) - 1			*/
typedef	long 			INT32;	/* Size - 32 bit, Range -(2^31) to (2^31) - 1	*/

typedef	unsigned char   	UINT64[8];	/* Size - 64 bit, Range 0 to (2^64) - 1			*/
typedef	char   			INT64[8];	/* Size - 64 bit, Range -(2^63) to (2^63) - 1	*/

typedef	float			REAL;	/* Size - 32 bit, Range 1.18E-38 to 3.39E+38	*/

typedef enum tPhyEnumDescriptor{
  PHY_BUSY,
  BUSY_RX,
  BUSY_TX,
  FORCE_TRX_OFF,
  IDLE,
  PHY_INVALID_PARAMETER,
  RX_ON,
  PHY_SUCCESS,
  TRX_OFF,
  TX_ON,
  PHY_UNSUPPORTED_ATTRIBUTE
}tPhyEnumDescriptor;


typedef union t_Messages{
    void*               MsgPtr;
    tPhyEnumDescriptor  PhyStatus;
}t_Messages;

typedef struct tMACMsg{
    UINT8 MsgId;
    t_Messages Message;
}tMACMsg;

typedef   UINT32  tMailMsgType;       /* Defined as 32 bit integer, application can cast it into */
                                      /* any 32 bit length structure*/

typedef union tMACMsgDetails{
  tMailMsgType Msg;
  tMACMsg MACMsg;
}tMACMsgDetails;


typedef struct {                         /* MailBox structure */
        tMailMsgType messages[  MAILBOX_SIZE  ]; /* Circular Q implementation, head & tail wraps around */
        UINT16 head  ;                   /* index to the  free slot for the message, provided count is not 0.*/
        UINT16 tail  ;                   /* index to the available message, provided count is not 0 */
        UINT16 count;                    /* Count of messages that is being held in this Q */
        UINT16 RxTaskQ;                  /* Q of tasks that are waiting to receive messages */
        UINT16 TxTaskQ;                  /* Q of task that are waiting to send messages */
 } S_Mail_Box;

//Structure for NLDE Data Request
typedef struct stNLDEDATAREQUEST
{
	UINT16	DstAddr;
	UINT8	NsduLength;
	UINT8 	*Nsdu;
	UINT8	NsduHandle;
	UINT8	BroadcastRadius;
	UINT8	DiscoverRoute;
	BOOL	SecurityEnable;

}stNLDEDATARequest;

typedef struct stNLDEDATACONFIRM
{
	UINT8	NsduHandle;
	UINT8	Status;

}stNLDEDATAConfirm;

typedef struct stNLDEDATAINDICATION
{
	UINT16	SrcAddress;
	UINT8	NsduLength;
	UINT8  	*Nsdu;
	UINT8	LinkQuality;
}stNLDEDATAIndication;


typedef struct stNETWORKDESCRIPTOR
{
	UINT16	PANId;
	UINT8	StackProfile;
	UINT8	ZigBeeVersion;
	UINT8	BeaconOrder;
	UINT8	SuperframeOrder;
	UINT8	LogicalChannel;
	BOOL	PermitJoining;
	struct  stNETWORKDESCRIPTOR *next;

}stNetworkDescriptor;

typedef union NIBAttributeValue_e {
            UINT8   ui;
            #ifdef B_64_BIT
            UINT64   	r;
            #else
            UINT8 r[8];
            #endif
            UINT16    i ;
            BOOL    b ;
            UINT16    d ;
            UINT8*  p ;
            UINT32    l;
}stNIBAttributeValue;

typedef stNetworkDescriptor* stNetworkDescriptorList;

typedef struct stNLMENWKDISCOVERYREQUEST
{
	UINT32 	ScanChannels;
	UINT8  	ScanDuration;

}stNLMENWKDISCOVERYRequest;

typedef struct stNLMENWKDISCOVERYCONFIRM
{
	stNetworkDescriptorList NetworkDescriptorList;
	UINT8 				    NetworkCount;
	UINT8 				    Status;

}stNLMENWKDISCOVERYConfirm;

typedef struct stNLMENWKFORMATIONREQUEST
{
	UINT32 	ScanChannels;
	UINT16 	PANId;
        UINT8 	ScanDuration;
        UINT8 	BeaconOrder;
	UINT8 	SuperframeOrder;
	BOOL	BatteryLifeExtension;

}stNLMENWKFORMATIONRequest;

typedef struct stNLMENWKFORMATIONCONFIRM
{
	UINT8 	Status;

}stNLMENWKFORMATIONConfirm;

typedef struct stNLMEPERMITJOININGREQUEST
{
	UINT8 	PermitDuration;

}stNLMEPERMITJOININGRequest;

typedef struct stNLMEPERMITJOININGCONFIRM
{
	UINT8 	Status;

}stNLMEPERMITJOININGConfirm;

typedef struct stNLMESTARTROUTERREQUEST
{
	UINT8 	BeaconOrder;
	UINT8 	SuperFrameOrder;
	BOOL  	BatteryLifeExtension;

}stNLMESTARTROUTERRequest;

typedef struct stNLMESTARTROUTERCONFIRM
{
	UINT8 	Status;

}stNLMESTARTROUTERConfirm;

typedef struct stNLMEJOINREQUEST
{
	UINT32  ScanChannels;
	UINT16 	PANId;
	UINT8   ScanDuration;
	UINT8   PowerSource;
	UINT8   RxOnWhenIdle;
	UINT8   MACSecurity;
	BOOL  	JoinAsRouter;
	BOOL    RejoinNetwork;
}stNLMEJOINRequest;

typedef struct stNLMEJOININDICATION
{
        #ifdef B_64_BIT
        UINT64   	ExtendedAddress;
        #else
        UINT8 ExtendedAddress[8];
        #endif
	UINT16 	        ShortAddress;
	UINT8	        CapabilityInformation;
    BOOL		SecureJoin;	

}stNLMEJOINIndication;

typedef struct stNLMEJOINCONFIRM
{
	UINT16	PANId;
	UINT8	Status;

}stNLMEJOINConfirm;

typedef struct stNLMEDIRECTJOINREQUEST
{
	#ifdef B_64_BIT
        UINT64   	ExtendedAddress;
        #else
        UINT8 ExtendedAddress[8];
        #endif

	UINT8	        CapabilityInformation;

}stNLMEDIRECTJOINRequest;

typedef struct stNLMEDIRECTJOINCONFIRM
{
	#ifdef B_64_BIT
        UINT64   	ExtendedAddress;
        #else
        UINT8  ExtendedAddress[8];
        #endif
	UINT8	        Status;
}stNLMEDIRECTJOINConfirm;

typedef struct stNLMERESETCONFIRM
{
	UINT8	Status;

}stNLMERESETConfirm;

typedef struct stNLMESYNCREQUEST
{
	BOOL	Track;

}stNLMESYNCRequest;

typedef struct stNLMESYNCCONFIRM
{
	UINT8	Status;

}stNLMESYNCConfirm;

typedef struct stNLMELEAVECONFIRM
{
	#ifdef B_64_BIT
        UINT64   	DeviceAddress;
        #else
        UINT8 DeviceAddress[8];
        #endif

	UINT8	  Status;

}stNLMELeaveConfirm;

typedef struct stNLMELEAVEINDICATION
{
	#ifdef B_64_BIT
        UINT64   	DeviceAddress;
        #else
        UINT8 DeviceAddress[8];
        #endif
}stNLMELeaveIndication;

typedef struct stNLMELEAVEREQUEST
{
	#ifdef B_64_BIT
        UINT64   	DeviceAddress;
        #else
        UINT8 DeviceAddress[8];
        #endif
        BOOL		RemoveChildren;
}stNLMELeaveRequest;



void V_ABZB_ZADKV2_Init_Bind_Info_Table(void);

/* Select the device role */
void V_ABZB_ZADKV2_Select_Device( UINT8 );

/* Update the bind table information in Co_ordinator */
void V_ABZB_ZADKV2_Update_Bind_Table( UINT8, UINT8 );

UINT16 Ui_ABZB_ZADKV2_GetDstAddress(void);

UINT16 Ui_ABZB_ZADKV2_Get_Nwk_Addr(void);

void fnS_Os_SendMessage( S_Mail_Box *MailBoxptr, tMailMsgType message );
void fnS_Os_GetMessage( S_Mail_Box *MailBoxptr, tMailMsgType *messageptr );

void fnLoad_SwTimer(UINT32 ABZB_Ul_Count, S_Mail_Box *MailBoxPtr, UINT8 MailMessage);

void V_ABZB_NWK_NLDEDATARequest(stNLDEDATARequest * ABZB_Pst_DataReq);
void V_ABZB_NWK_NLMENETWORKDISCOVERYRequest(stNLMENWKDISCOVERYRequest * ABZB_Pst_DiscoveryReq);
void V_ABZB_NWK_NLMENETWORKFORMATIONRequest(stNLMENWKFORMATIONRequest * ABZB_Pst_NetFormationReq);
void V_ABZB_NWK_NLMEPERMITJOININGRequest(stNLMEPERMITJOININGRequest * ABZB_Pst_PermitJoinReq);
void V_ABZB_NWK_NLMEDIRECTJOINRequest(stNLMEDIRECTJOINRequest *ABZB_Pst_DirectJoinReq);
void V_ABZB_NWK_NLMEJOINRequest(stNLMEJOINRequest * ABZB_Pst_JoinReq);
void V_ABZB_NWK_NLMESTARTROUTERRequest(stNLMESTARTROUTERRequest * ABZB_Pst_StartRouterReq);
void V_ABZB_NWK_NLMERESETRequest(void);
void V_ABZB_NWK_NLMESYNCRequest(stNLMESYNCRequest * ABZB_Pst_SyncReq);
void V_ABZB_NWK_NLMELEAVERequest(stNLMELeaveRequest * ABZB_Pst_LeaveReq);

void V_ABZB_NWK_NLDEDATAConfirm(stNLDEDATAConfirm *ABZB_Pst_DataConfirm);
void V_ABZB_NWK_NLDEDATAIndication(stNLDEDATAIndication *ABZB_Pst_DataIndication);
void V_ABZB_NWK_NLMENETWORKDISCOVERYConfirm(stNLMENWKDISCOVERYConfirm * ABZB_Pst_DiscoveryConfirm);
void V_ABZB_NWK_NLMENETWORKFORMATIONConfirm(stNLMENWKFORMATIONConfirm * ABZB_Pst_NetFormationConfirm);
void V_ABZB_NWK_NLMEPERMITJOININGConfirm(stNLMEPERMITJOININGConfirm * ABZB_Pst_PermitJoinConfirm);
void V_ABZB_NWK_NLMEDIRECTJOINConfirm(stNLMEDIRECTJOINConfirm *ABZB_Pst_DirectJoinConfirm);
void V_ABZB_NWK_NLMEJOINConfirm(stNLMEJOINConfirm * ABZB_Pst_JoinConfirm);
void V_ABZB_NWK_NLMEJOINIndication(stNLMEJOINIndication * ABZB_Pst_JoinIndication);
void V_ABZB_NWK_NLMESTARTROUTERConfirm(stNLMESTARTROUTERConfirm * ABZB_Pst_StartRouterConfirm);
void V_ABZB_NWK_NLMERESETConfirm(stNLMERESETConfirm *ABZB_Pst_ResetConfirm);
void V_ABZB_NWK_NLMESYNCConfirm(stNLMESYNCConfirm * ABZB_Pst_SyncConfirm);
void V_ABZB_NWK_NLMESYNCIndication(void);
void V_ABZB_NWK_NLMELEAVEConfirm(stNLMELeaveConfirm * ABZB_Pst_LeaveConfirm);
void V_ABZB_NWK_NLMELEAVEIndication(stNLMELeaveIndication * ABZB_Pst_LeaveIndication);

void V_ABZB_NWK_Init(UINT8 DeviceRole,UINT8 StackProfile,BOOL Security);

void V_ABZB_APP_NetworkResetRequest0(void);

void V_ABZB_APP_NetworkFormationRequest0(void);
void V_ABZB_APP_PermitJoinRequest0(void);
void V_ABZB_APP_NetworkDiscoveryRequest0(void);
void V_ABZB_APP_NetworkJoinRequest0(void);
void V_ABZB_APP_Network_StartRouterRequest0(void);
void V_ABZB_APP_DeviceConfig0(void);
void V_ABZB_APP_Forever_Loop(void);
void V_ABZB_APP_ROUTER_INIT(void);
void V_ABZB_APP_COORDINATOR_INIT(void);
void V_ABZB_ZADKV2_Binding_Table_config(void);
void V_ABZB_ASP_APP_SWITCH_LED_DemoInit(void);
void V_ABZB_APP_Send_NLDEDataRequest(void);
void V_ABZB_APP_Send_NLME_PermitJoin(UINT8 ABZB_Uch_PermitDuration);
void V_ABZB_APP_Send_PermitEnable_To_Router(void);

void V_ABZB_ASP_SLC_HardwareInit(void);
void V_ABZB_ASP_SLC_OnOffSRC(UINT8 ABZB_Uch_LED_ID);
void V_ABZB_ASP_SRC_HardwareInit(void);
UINT8 Uch_ABZB_ASP_SRC_OnOffSRC(void);
void V_ABZB_ZADKV2_Switch_Status( UINT8 );


///Variable declarations
extern S_Mail_Box MailBox_Array[];

#endif    // _ABZB_FOUR_NODE_APP_H_
