/**************************************************************************************************
 *  @file ABZB_ASP_TI_SLC.c.
 *
 *  This file contains common procedures used for LED initialisation and handling
 *

 *
 *  Copyright 2004-2005. Airbee Wireless Corporation. All rights reserved.
 *	This program is protected by US and International copyright laws.

 *	Warning: This program is protected by copyright law and international
 *	treaties. Unauthorized reproduction or distribution of this program, or
 *	any portion of it, may result in severe civil or criminal penalties, and
 *	will be prosecuted to the maximum extent possible under the law.*
 *
 *
 *	Date		Author			Modifications		Version
 *  01 Jul 05	        Airbee		          NONE		          1.0
 *																
 *
* ***************************************** Header File Inclusion ********************************/
#include "ABZB_HAL_Platform.h"     // Header file for selection for Hardware platform
#include "ABZB_FOUR_NODE_APP.h"
#include "stdlib.h"                     //Standard Library used for Dynamic memory allocation

#ifdef ABZB_ASP_TI_LED

/***********************************************************************************************
Description:	
This function is used to initialize the SLC hardware module which includes the PORT iinitialisation
abd configurations

Function Owner  :	Airbee Wireless
	
Return Type     :	void

Parameter Passed:       -

Called from     :	Invoked from the file APP_TASK.c on entering the Airbee_AppTask0.

***********************************************************************************************/

void V_ABZB_ASP_SLC_HardwareInit(void)
{
  M_ABZB_DSP_PORT1DIR |= BIT0;        //MAKING THE PORT1 (BITO) AS OUTPUT
  M_ABZB_DSP_PORT1OUTPUT &= ~(BIT0);    //WRITING 0 TO THE PINS (P1.0)

  M_ABZB_DSP_PORT1DIR |= BIT1;        //MAKING THE PORT1 (BIT1) AS OUTPUT (FOR JOIN AND FORMATION INFO)
  M_ABZB_DSP_PORT1OUTPUT &= ~(BIT1);    //WRITING 0 TO THE PINS (P1.1)
}	



/***********************************************************************************************
Description:	
This function is used when the application uses the SLC functionality(glow LED)
on the NLDE DATA Indication).

Function Owner  :	Airbee
	
Return Type     :	void

Parameter Passed:       UINT8, The ID of the LED that to be toggled

Called from     :	Invoked from the file APP_TASK.c in the function V_ABZB_MAC_Main_Airbee_AppTask0()
after on getting the message NLDE_DATA_INDICATION from the APP mailbox.

***********************************************************************************************/

void V_ABZB_ASP_SLC_OnOffSRC(UINT8 ABZB_Uch_LED_ID)
{
  (ABZB_Uch_LED_ID == M_ABZB_LED1)?M_ABZB_LAMP1_SLC_TOGGLE:M_ABZB_LAMP2_SLC_TOGGLE;
}
#endif    //ABZB_ASP_TI_LED
